/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package cz.muni.fi.pb138.jaxendemo;

import java.io.IOException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.TransformerException;
import org.jaxen.JaxenException;
import org.jaxen.Navigator;
import org.jaxen.XPath;
import org.jaxen.function.StringFunction;
import org.w3c.dom.Node;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

/**
 *
 * @author tomp
 */
public class Main {

    private Main() { }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args)
            throws IOException, SAXException, TransformerException,
            ParserConfigurationException, JaxenException {

        DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
        factory.setNamespaceAware(true);
        DocumentBuilder builder = factory.newDocumentBuilder();

        InputSource data = new InputSource("purchase.xml");
        Node doc = builder.parse(data);

        // There are different XPath classes in different packages
        // for the different APIs Jaxen supports
        XPath expression = new org.jaxen.dom.DOMXPath("//po:Price/text()");
        expression.addNamespace("po", "http://www.marchal.com/2006/po");
        
        Navigator navigator = expression.getNavigator();

        for (Object o : expression.selectNodes(doc)) {
            Node result = (Node) o;
            String value = StringFunction.evaluate(result, navigator);
            System.out.println(value);
        }
    }
}
